# Recupere les infos de bases de zephir
#  + les zephir ID des != module


import os
import sys
import xmlrpclib
from inc_connect   import *
from tools import *

s_sVARIABLE_RNE='rne'
s_sVARIABLE_SERVEURMODULE='module_actuel'
s_sVARIABLE_MODULEID='id'
s_sVARIABLE_SERVEURID='id'

oProxy=xmlrpclib.ServerProxy(sUrlZephir)

# Construction de la correspondance ModuleId/Nom
oListModules=oProxy.modules.get_module()[1]
oListeModuleName={}
sys.stdout.write('#Liste des modules : ')
for oModule in oListModules:
    sServeurName=getServeurName(oModule['libelle'])
    oListeModuleName[oModule[s_sVARIABLE_MODULEID]]=sServeurName
    sys.stdout.write('#'+str(oModule[s_sVARIABLE_MODULEID])+'='+sServeurName+" ")
sys.stdout.write('\n\n')


# Recupere  les type d'etabs
oListTypes=oProxy.etabs.get_types()[1][0]

sys.stdout.write('#Recuperation des infos :\n ')
etabs=convert(oProxy.etabs.get_etab()[1])
serveurs_etabs=convert(oProxy.sentinelle.get_serveur_etab()[1])
liste=[]
for etab in etabs:
    ligne=etab[s_sVARIABLE_RNE]+"|"   # Recuperation du code rne
    #if etab[s_sVARIABLE_RNE] != '0210000A':
    #	continue    

    # Recuperation des infos
    for cle,valeur in etab.items():
        #print cle+"%%"+str(valeur)
        if (cle=='type'):
            valeur=getEtabType(oListTypes[str(valeur)]) # Convertion du Type, en LYC,LP ou CLG
        ligne+=cle+"%%"+str(valeur).replace("\n","")+"|"

    # Recuperation des serveurs pour Rne
    serveursid={}
    #print ""
    oListServeurs=serveurs_etabs.get(etab[s_sVARIABLE_RNE], [])
    for serveur in oListServeurs:
        iIdDuModule=serveur[1]
        iIdDuServeur=serveur[0]
        sServeur=oListeModuleName[iIdDuModule]
        #print sServeur+" "+str(iIdDuServeur)
	if sServeur != "":
            if (not serveursid.has_key(sServeur)):
		#print "Nvle ref " + sServeur
		serveursid[sServeur]=[]
	    serveursid[sServeur].append(str(iIdDuServeur))
	#print serveursid

    for srv in ["zephid_horus","zephid_amon","zephid_scribe"]:
        if not serveursid.has_key(srv):
            serveursid[srv]=[]; serveursid[srv].append("")


    # Liste des serveurs
    for serveur in serveursid:
	ligne+=(serveur+"%%"+",".join(serveursid[serveur])+"|")

    # Ajout des etabs dans la liste            
    liste.append( ligne)
    print(ligne)


# =============================================
# IMPORT DE MASSE D'UN FICHIER CSV
# SYNTAX DU FICHIER
# ---------------------------------------------
# rne;composante1;...;composanteN
# rne1;val1.1;..;val1.N
# ....
# rneN;valN.1;valN.N
# ==============================================
FILE="/etc/sentinelle/massimport.csv"
SEP=";"
if os.path.exists(FILE) and os.path.isfile(FILE):
    f= open(FILE,'r')
    sHeader=f.readline().replace('\n','')
    oArrHeader=sHeader.split(SEP)
    for line in f:
        line=line.replace('\n','')
        oArrFields=line.split(SEP)
        i=0
        for field in oArrFields:
            if i==0:
                s= "%s" % field
            else:
                s= "%s|%s%%%%%s" % (s,oArrHeader[i],field)
            i=i+1
            if i==len(oArrHeader):
                break
        print s
    f.close()


