#!/usr/bin/python
# -*- coding: UTF-8 -*-

from sys import argv
from time import time, sleep
from os import stat, system, remove
from os.path import exists

FILE_PATH = '/tmp/zephir/' + argv[1] + '.conf'
LOCK_FILE = '/var/lock/zephirmeasure'
# durée de validité des données d'un serveur (en secondes)
UPDATE_INTERVAL = 180

if not exists(FILE_PATH) or stat(FILE_PATH).st_mtime < (time() - UPDATE_INTERVAL):
    # si la récupération n'est pas déjà en cours
    if not exists(LOCK_FILE):
        lck = open(LOCK_FILE, 'w')
        lck.close()
        # on met à jour les informations sur les serveurs
        system('python scripts/ServerConf.py')
        if exists(LOCK_FILE):
            remove(LOCK_FILE)
    else:
        # sinon on attend que la mesure se termine
        wait_time = 0
        while (exists(LOCK_FILE) and wait_time < UPDATE_INTERVAL):
            # on attend 3 secondes avant de revérifier
            sleep(3)
            wait_time += 3
        if wait_time >= UPDATE_INTERVAL:
            # temps limite dépassé, on supprime le lock pour permettre un nouvel appel à zephir
            if exists(LOCK_FILE): remove(LOCK_FILE)
try:
    print open(FILE_PATH).read()[:-1]
except:
    pass
